var app;

app = angular.module("surf-better", ["ionic", "ngResource", "angular-data.DSCacheFactory", "fixes", "angular-authio-jwt"]).run(function($ionicPlatform, $rootScope, res, prettifyer, user, authio, authioLogin, mapper) {
  console.log(">>>app.coffee:5");
  $ionicPlatform.ready(function() {
    console.log(">>>app.coffee:7");
    authioLogin.activate();
    console.log(">>>app.coffee:9");
    if (window.cordova && window.cordova.plugins.Keyboard) {
      cordova.plugins.Keyboard.hideKeyboardAccessoryBar(true);
    }
    if (window.StatusBar) {
      StatusBar.styleDefault();
    }
    console.log(">>>app.coffee:10");
    return authio.login("facebook").then(function(res) {
      console.log(">>>app.coffee:12");
      return user.setUser(mapper.mapUser(res), true);
    });
  });
  user.initialize();
  return $rootScope.prettifyer = prettifyer;
}).config(function($stateProvider, $urlRouterProvider) {
  $stateProvider.state("tab", {
    url: "/tab",
    abstract: true,
    templateUrl: "tabs/tab.html"
  }).state("tab.home", {
    url: "/home",
    views: {
      "tab-home": {
        templateUrl: "tabs/tab-home.html",
        controller: "HomeController"
      }
    }
  }).state("tab.pals", {
    url: "/pals",
    views: {
      "tab-home": {
        templateUrl: "tabs/tab-pals.html",
        controller: "PalsController"
      }
    }
  }).state("tab.forecast", {
    url: "/forecast",
    views: {
      "tab-home": {
        templateUrl: "tabs/tab-forecast.html",
        controller: "ForecastController"
      }
    }
  }).state("tab.favs", {
    url: "/favs",
    views: {
      "tab-favs": {
        templateUrl: "tabs/tab-favs.html",
        controller: "FavsController"
      }
    }
  }).state("tab.user", {
    url: "/user",
    views: {
      "tab-user": {
        templateUrl: "tabs/tab-user.html",
        controller: "UserController"
      }
    }
  });
  $urlRouterProvider.otherwise("/tab/home");
});

app.constant('$ionicLoadingConfig', {
  template: 'Loading ...'
});

app.config(function(DSCacheFactoryProvider) {
  return DSCacheFactoryProvider.setCacheDefaults({
    maxAge: 1000 * 60 * 60 * 24,
    deleteOnExpire: 'aggressive',
    storageMode: 'localStorage'
  });
});

app.config(function(authioLoginProvider, authConfig) {
  return authioLoginProvider.initialize({
    oauthio_key: authConfig.oauthio_key,
    baseUrl: authConfig.apiUrl,
    user: authConfig.user
  });
});

"use strict";
app.constant("webApiConfig", {
  url: "http://surf-better-web-api.herokuapp.com/"
});

app.constant("authConfig", {
  oauthio_key: "9E7SoR97JvCrmryqfLMBC5Fe5ic",
  apiUrl: "http://auth-server-oauthio.herokuapp.com/"
});

"use strict";
app.filter("time", function() {
  return function(dateTime) {
    return moment.utc(dateTime, "DD-MM-YYYYTHH:mm").format("HH:mm");
  };
});

var app;

app = angular.module("angular-authio-jwt", ["angular-data.DSCacheFactory"]);


/*
app.config (DSCacheFactoryProvider) ->
  DSCacheFactoryProvider.setCacheDefaults
    maxAge: 1000 * 60 * 60 * 24
    deleteOnExpire: 'aggressive'
    storageMode: 'localStorage'
 */

app.factory("authioEndpoints", function($q, $http) {
  var _authBaseUrl;
  console.log(">>>angular-authio-jwt.coffee:11");
  _authBaseUrl = null;
  return {
    setUrl: function(url) {
      return _authBaseUrl = url;
    },
    getToken: function() {
      return $http.get(_authBaseUrl + "oauth/token").then(function(res) {
        return res.data;
      });
    },
    signin: function(provider, code, token) {
      var data;
      data = {
        code: code,
        provider: provider,
        token: token
      };
      console.log(">>>angular-authio-jwt.coffee:27");
      return $http.post(_authBaseUrl + "oauth/signin", data).then(function(res) {
        return res.data;
      });
    },
    user: function(jwt) {
      return $http.get(_authBaseUrl + "oauth/user", {
        headers: {
          authorization: "Bearer " + jwt
        }
      }).then(function(res) {
        return res.data;
      });
    },
    setData: function(jwt, key, data) {
      return $http.put(_authBaseUrl + ("oauth/data/" + key), data, {
        headers: {
          authorization: "Bearer " + jwt
        }
      }).then(function(res) {
        return res.data;
      });
    }
  };
});

app.provider("authioLogin", function() {
  var _authBaseUrl, _key, _token, _user;
  _user = null;
  _key = null;
  _authBaseUrl = null;
  _token = null;
  return {
    initialize: function(opts) {
      _authBaseUrl = opts.baseUrl;
      _user = opts.user;
      return _key = opts.oauthio_key;
    },
    $get: function($q, authioEndpoints) {
      var popup;
      popup = function(provider, token, opts) {
        var deferred, _opts;
        deferred = $q.defer();
        _opts = opts ? angular.copy(opts) : {};
        _opts.state = token;
        OAuth.popup(provider, _opts).done(deferred.resolve).fail(deferred.reject);
        return deferred.promise;
      };
      return {
        login: function(provider, opts) {
          if (_user) {
            return $q.when(_user);
          }
          return popup(provider, _token, opts).then(function(res) {
            return authioEndpoints.signin(provider, res.code, _token);
          });
        },
        logout: function(provider) {
          return OAuth.clearCache(provider);
        },
        activate: function() {
          authioEndpoints.setUrl(_authBaseUrl);
          OAuth.initialize(_key);
          return authioEndpoints.getToken().then(function(res) {
            return _token = res.token;
          });
        }
      };
    }
  };
});

app.factory("authio", function($q, DSCacheFactory, authioLogin, authioEndpoints) {
  var cache, getJWT, login, setJWT;
  cache = DSCacheFactory("authioCache");
  getJWT = function() {
    return cache.get("_jwt");
  };
  setJWT = function(jwt) {
    if (jwt) {
      return cache.put("_jwt", jwt);
    } else {
      return cache.remove("_jwt", jwt);
    }
  };
  login = function(provider, opts) {
    var jwt, promise;
    jwt = getJWT();
    if (!jwt && (opts != null ? opts.force : void 0)) {
      promise = $q.when();
      if (opts != null ? opts.confirm : void 0) {
        promise = opts.confirm();
      }
      return promise.then(function() {
        return authioLogin.login(provider, opts).then(function(res) {
          setJWT(res.token);
          authioLogin.logout(provider);
          return res;
        });
      });
    } else if (jwt) {
      return authioEndpoints.user(jwt)["catch"](function() {
        setJWT(void 0);
        return login(provider, opts);
      });
    } else {
      return $q.reject(new Error("Token not found"));
    }
  };
  return {
    setData: function(key, data) {
      var jwt;
      jwt = getJWT();
      if (jwt) {
        return authioEndpoints.setData(jwt, key, data);
      } else {
        return $q.reject(new Error({
          status: 401
        }));
      }
    },
    login: login,
    logout: function() {
      return setJWT(void 0);
    },
    getJWT: getJWT
  };
});

app.controller("FavsController", function($scope, $ionicModal, spot, forecast, user, $state, geoLocator) {
  var geo, loadSpots, setReports, spots;
  console.log("Favs Controller");
  geo = null;
  $scope.favs = user.user.settings.favs;
  loadSpots = function(term) {
    if ((!term && geo) || (term && term.length > 2)) {
      return spot.get(term, geo).then(function(res) {
        return $scope.spotsList = res.map(function(r) {
          r.descr = [r.city, r.region, r.country].filter(function(f) {
            return f;
          }).join(", ");
          return r;
        });
      });
    } else {
      return $scope.spotsList = null;
    }
  };
  $ionicModal.fromTemplateUrl('modals/spotSelector.html', {
    scope: $scope,
    animation: 'slide-in-up'
  }).then(function(modal) {
    return $scope.spotSelectorModal = modal;
  });
  $scope.openSpotSelectorModal = function() {
    $scope.spotSelectorModal.show();
    return geoLocator.getPosition().then(function(res) {
      geo = res.lat + "," + res.lon;
      if (!$scope.spotsList) {
        return loadSpots();
      }
    });
  };
  $scope.closeSpotSelectorModal = function() {
    return $scope.spotSelectorModal.hide();
  };
  $scope.$on('$destroy', function() {
    return $scope.spotSelectorModal.remove();
  });
  $scope.onSpotTermChanged = loadSpots;
  $scope.selectSpot = function(s) {
    user.addSpot(s);
    return $scope.spotSelectorModal.hide();
  };
  $scope.removeFav = function(s) {
    return user.removeSpot(s);
  };
  $scope.setHome = function(s) {
    return user.setHome(s);
  };
  $scope.openHome = function(s) {
    user.setHome(s);
    return $state.go("tab.home");
  };
  $scope.isHome = user.isHome;
  $scope.canAddFav = function() {
    return $scope.favs.length < 5;
  };
  $scope.canRemoveFav = function() {
    return $scope.favs.length > 1;
  };
  setReports = function(reports) {
    var fav, _i, _len, _ref, _results;
    if (reports) {
      _ref = $scope.favs;
      _results = [];
      for (_i = 0, _len = _ref.length; _i < _len; _i++) {
        fav = _ref[_i];
        _results.push(fav.report = reports.filter(function(f) {
          return f.spot === fav.code;
        })[0]);
      }
      return _results;
    }
  };
  spots = $scope.favs.map(function(m) {
    return m.code;
  }).join(",");
  setReports(forecast.getInstantReportsCache(spots));
  return forecast.getInstantReports(spots).then(setReports);
});

app.controller("ForecastController", function($scope, forecast, $ionicScrollDelegate, $ionicPosition, user) {
  var homeCode, setForecast;
  console.log("Forecast Controller");
  setForecast = function(serviceData, scroll) {
    var idx;
    if (serviceData) {
      $scope.forecast = serviceData;
      if (scroll) {
        idx = $scope.forecast.conditions.indexOf($scope.forecast.conditions.filter(function(f) {
          return f.isCurrent;
        })[0]);
        return $ionicScrollDelegate.$getByHandle("forecast-scroll").scrollTo(0, 112 * idx, false);
      }
    }
  };
  $scope.$on("$destroy", function() {
    var delegate;
    delegate = $ionicScrollDelegate.$getByHandle("forecast-scroll");
    return delegate.forgetScrollPosition();
  });
  homeCode = user.getHome().code;
  setForecast(forecast.getForecastCache(homeCode));
  return forecast.getForecast(homeCode).then(function(res) {
    return setForecast(res, true);
  });
});

app.controller("HomeController", function($scope, $ionicModal, forecast, report, user, res) {
  var home, setInstantReport;
  console.log("Home Controller");
  $scope.data = {
    message: ""
  };
  $ionicModal.fromTemplateUrl('modals/addMessage.html', {
    scope: $scope,
    animation: 'slide-in-up'
  }).then(function(modal) {
    return $scope.addMessageModal = modal;
  });
  $scope.closeAddMessageModal = function() {
    return $scope.addMessageModal.hide();
  };
  $scope.$on('$destroy', function() {
    return $scope.addMessageModal.remove();
  });
  $scope.defMsgList = [res.str.coldwater, res.str.crowdalert, res.str.eventalert, res.str.strongwaves, res.str.weakwaves].map(function(m) {
    return {
      text: m,
      selected: false
    };
  });
  $ionicModal.fromTemplateUrl('modals/defMsgList.html', {
    scope: $scope,
    animation: 'slide-in-up'
  }).then(function(modal) {
    return $scope.defMsgListModal = modal;
  });
  $scope.openDefMsgListModal = function() {
    return $scope.defMsgListModal.show();
  };
  $scope.closeDefMsgListModal = function() {
    var msg;
    msg = $scope.data.message ? $scope.data.message : "";
    $scope.data.message = (msg ? msg + ", " : "") + $scope.defMsgList.filter(function(f) {
      return f.selected && msg.indexOf(f.text) === -1;
    }).map(function(m) {
      return m.text;
    }).join(", ");
    return $scope.defMsgListModal.hide();
  };
  $scope.cancelDefMsgListModal = function() {
    return $scope.defMsgListModal.hide();
  };
  $scope.$on('$destroy', function() {
    return $scope.defMsgListModal.remove();
  });
  setInstantReport = function(serviceData) {
    if (serviceData) {
      $scope.rating = serviceData.rating;
      $scope.nextRating = serviceData.nextRating;
      return $scope.report = serviceData.report;
    }
  };
  home = user.getHome();
  if (home) {
    setInstantReport(forecast.getInstantReportCache(home.code));
    forecast.getInstantReport(home.code).then(setInstantReport);
  } else {
    $scope.$on("user.changed", function() {
      return forecast.getInstantReport(user.getHome().code).then(setInstantReport);
    });
  }
  $scope.sendReport = function(reportCode) {
    home = user.getHome().code;
    return report.send(home, reportCode).then(function(res) {
      if (user.getHome().code === home) {
        $scope.report = res;
      } else {
        setInstantReport(forecast.getInstantReportCache(user.getHome().code));
      }
      return $scope.addMessageModal.show();
    });
  };
  return $scope.addReportMessage = function(message) {
    return report.addMessage(message).then(function() {
      return $scope.closeAddMessageModal();
    }, function(err) {
      return $scope.closeAddMessageModal();
    });
  };
});

app.controller("PalsController", function($scope, report, user) {
  var homeCode, setMessages;
  console.log("Pals Controller");
  setMessages = function(serviceData) {
    if (serviceData) {
      return $scope.messages = serviceData.items;
    }
  };
  homeCode = user.getHome().code;
  setMessages(report.getCache(homeCode));
  return report.get(homeCode).then(setMessages);
});

app.controller("UserController", function($scope, user, spot, res) {
  var updScopeData;
  console.log("User Controller");
  $scope.login = user.login;
  $scope.logout = user.logout;
  $scope.isLogin = user.isLogin;
  $scope.reset = user.reset;
  $scope.culturesList = [
    {
      code: "eu",
      name: res.str.eu
    }, {
      code: "uk",
      name: res.str.uk
    }, {
      code: "us",
      name: res.str.us
    }
  ];
  $scope.langsList = [
    {
      code: "en",
      name: res.str.langen
    }, {
      code: "pt",
      name: res.str.langpt
    }, {
      code: "fr",
      name: res.str.langfr
    }, {
      code: "es",
      name: res.str.langes
    }
  ];
  $scope.setCulture = user.setCulture;
  $scope.setLang = user.setLang;
  $scope.user = user.user;
  $scope.data = {};
  updScopeData = function() {
    $scope.data.culture = $scope.culturesList.filter(function(f) {
      return f.code === user.getCulture();
    })[0];
    return $scope.data.lang = $scope.langsList.filter(function(f) {
      return f.code === user.getLang();
    })[0];
  };
  $scope.$on("user.reset", function() {
    return updScopeData();
  });
  return updScopeData();
});

app.factory("cache", function(DSCacheFactory) {
  var cache, _ver;
  cache = DSCacheFactory("app-cache");
  _ver = "1";
  return {
    get: function(name) {
      var currTime, expired, val;
      val = cache.get(name);
      if (val && val._val) {
        if (val._ver !== _ver) {
          cache.remove(name);
          val._val = void 0;
        } else if (val._expired) {
          expired = val._expired;
          currTime = (new Date()).getTime();
          if (expired <= currTime) {
            cache.remove(name);
            val._val = void 0;
          }
        }
        val = val._val;
      }
      return val;
    },
    put: function(name, val, expired) {
      var exp;
      if (expired) {
        if (expired === "eod") {
          exp = moment().endOf("day").valueOf();
          return cache.put(name, {
            _val: val,
            _expired: exp,
            _ver: _ver
          });
        } else {
          throw new Error("Not implemented");
        }
      } else {
        return cache.put(name, {
          _val: val,
          _ver: _ver
        });
      }
    },
    rm: function(name) {
      return cache.remove(name);
    },
    clean: function() {
      return cache.removeAll();
    },
    replace: function(coll, name, val) {
      this.pop(coll, name);
      return this.push(coll, name, val);
    },
    push: function(coll, name, val) {
      if (!this.get(coll + "." + name)) {
        this.put(coll + "." + name, val);
        return true;
      } else {
        return false;
      }
    },
    pop: function(coll, name) {
      return this.rm(coll + "." + name);
    },
    item: function(coll, name) {
      return this.get(coll + "." + name);
    },
    all: function(coll) {
      var key, _i, _len, _ref, _results;
      _ref = cache.keys().filter(function(f) {
        return f.indexOf(coll + ".") === 0;
      });
      _results = [];
      for (_i = 0, _len = _ref.length; _i < _len; _i++) {
        key = _ref[_i];
        _results.push(this.get(key));
      }
      return _results;
    }
  };
});

app.factory("culture", function($rootScope) {
  var culture, data;
  culture = "eu";
  data = {
    eu: ["m", "kph", "c", "km"],
    uk: ["ft", "mph", "c", "mi"],
    us: ["ft", "mph", "f", "mi"]
  };
  return {
    setCulture: function(c) {
      return culture = c;
    },
    getCulture: function() {
      return culture;
    },
    getHeight: function(m) {
      if (data[this.getCulture()][0] !== "m") {
        return Math.round(m * 3.2808);
      } else {
        return m;
      }
    },
    getHeightUnits: function() {
      return data[this.getCulture()][0];
    },
    getSpeed: function(s) {
      if (data[this.getCulture()][1] !== "mph") {
        return Math.round(1.6 * s);
      } else {
        return s;
      }
    },
    getSpeedUnits: function() {
      return data[this.getCulture()][1];
    },
    getTemp: function(c) {
      if (data[this.getCulture()][2] !== "c") {
        return Math.round(c * 1.8 + 32);
      } else {
        return c;
      }
    },
    getTempUnits: function() {
      if (data[this.getCulture()][2] === "c") {
        return "c";
      } else {
        return "F";
      }
    },
    getDist: function(km) {
      if (data[this.getCulture()][3] !== "km") {
        return Math.round(km * 0.621371);
      } else {
        return km;
      }
    },
    getDistUnits: function() {
      return data[this.getCulture()][3];
    }
  };
});

app.factory("forecast", function($q, $resource, webApiConfig, mapper, cache) {
  return {
    getInstantReportsCache: function(spot) {
      return cache.get("instant-reports." + spot);
    },
    getInstantReportCache: function(spot) {
      return cache.get("instant-report." + spot);
    },
    getForecastCache: function(spot) {
      return cache.get("forecast." + spot);
    },
    getInstantReport: function(spot) {
      return this.getInstantReports(spot).then(function(res) {
        cache.put("instant-report." + spot, res[0], "eod");
        return res[0];
      });
    },
    getInstantReports: function(spot) {
      var defer, resource;
      resource = $resource(webApiConfig.url + "instant-report/:spot", {
        code: "@spot"
      });
      defer = $q.defer();
      resource.query({
        spot: spot
      }, (function(res) {
        res = mapper.mapInstantReports(res);
        cache.put("instant-reports." + spot, res, "eod");
        return defer.resolve(res);
      }), (function(response) {
        return defer.reject(response);
      }));
      return defer.promise;
    },
    getForecast: function(spot) {
      var defer, resource;
      resource = $resource(webApiConfig.url + "forecast/:spot", {
        code: "@spot"
      });
      defer = $q.defer();
      resource.get({
        spot: spot
      }, (function(res) {
        res = mapper.mapForecast(res);
        cache.put("forecast." + spot, res, "eod");
        return defer.resolve(res);
      }), (function(response) {
        return defer.reject(response);
      }));
      return defer.promise;
    }
  };
});

app.factory("geoLocator", function($q) {
  return {
    getPosition: function() {
      var deferred, geolocationError, geolocationOptions, geolocationSuccess;
      deferred = $q.defer();
      geolocationSuccess = function(position) {
        return deferred.resolve({
          lat: position.coords.latitude,
          lon: position.coords.longitude
        });
      };
      geolocationError = function(err) {
        return console.log(">>>geo.coffee:11", err);
      };
      geolocationOptions = {
        enableHighAccuracy: true,
        timeout: 1000 * 60 * 60,
        maximumAge: 1000 * 60 * 15
      };
      navigator.geolocation.getCurrentPosition(geolocationSuccess, geolocationError, geolocationOptions);
      return deferred.promise;
    }
  };
});

app.factory("mapper", function(prettifyer, culture) {
  return {
    mapInstantReports: function(reports) {
      return reports.map((function(_this) {
        return function(m) {
          return {
            spot: m.spot,
            rating: _this.mapReportForecast(m.forecast[0]),
            nextRating: m.forecast.length ? _this.mapReportForecast(m.forecast[1]) : void 0,
            report: _this.mapReports(m.reports)
          };
        };
      })(this));
    },
    mapForecast: function(forecast) {
      var ct, dt, exactDT, i, _i, _len, _ref;
      exactDT = moment.utc(forecast.dateRange.exact);
      forecast.units = {
        speed: culture.getSpeedUnits(),
        height: culture.getHeightUnits(),
        temperature: culture.getTempUnits()
      };
      _ref = forecast.conditions;
      for (i = _i = 0, _len = _ref.length; _i < _len; i = ++_i) {
        ct = _ref[i];
        ct.weather.temperature = culture.getTemp(ct.weather.temperature);
        ct.swell.height = culture.getHeight(ct.swell.height);
        ct.wind.speed = culture.getSpeed(ct.wind.speed);
        ct.wind.gusts = culture.getSpeed(ct.wind.gusts);
        dt = moment.utc(ct.dateTime);
        ct.time = dt.format("HH:SS");
        ct.rating.stars = prettifyer.getStars(ct.rating.solid, ct.rating.faded);
        if ((dt <= exactDT && exactDT < moment.utc(forecast.conditions[i + 1].dateTime))) {
          ct.isCurrent = true;
        } else {
          ct.isCurrent = false;
        }
      }
      return forecast;
    },
    mapReportForecast: function(forecast) {
      return {
        stars: prettifyer.getStars(forecast.rating.solid, forecast.rating.faded),
        time: moment(forecast.dt).format("HH:mm")
      };
    },
    mapReports: function(reports) {
      if (reports.length) {
        return {
          messages: reports.map(function(m) {
            return {
              code: m.code
            };
          }),
          time: moment(reports[0].dt).format("HH:mm")
        };
      } else {
        return {
          messages: [],
          time: null
        };
      }
    },
    mapSpots: function(spots) {
      return spots.map(function(r) {
        var parts;
        r.code = r.id;
        r.units = {
          dist: culture.getDistUnits()
        };
        parts = [r.city, r.region, r.country].filter(function(f) {
          return f;
        });
        r.descr = parts.join(", ");
        if (r.dist) {
          r.dist = culture.getDist(r.dist);
        }
        return r;
      });
    },
    mapUser: function(user) {
      var res, _ref;
      res = {
        profile: user.profile
      };
      if ((_ref = user.data) != null ? _ref.surf_better : void 0) {
        res.settings = user.data.surf_better;
      }
      return res;
    }
  };
});

app.factory("prettifyer", function(res) {
  return {
    getText: function(code) {
      switch (code) {
        case "no":
          return res.str.nosurf;
        case "dunno":
          return res.str.dunno;
        case "yes":
          return res.str.surf;
      }
    },
    getUnkStars: function(solid, faded) {
      return [0, 1, 2, 3, 4].map(function() {
        return {
          type: "unk"
        };
      });
    },
    getStars: function(solid, faded) {
      var i, notFaded, star, stars, _i, _len;
      stars = [0, 1, 2, 3, 4].map(function() {
        return {
          type: "empty"
        };
      });
      notFaded = solid - faded;
      if (notFaded < 0) {
        notFaded = 0;
      }
      if (notFaded >= 0) {
        for (i = _i = 0, _len = stars.length; _i < _len; i = ++_i) {
          star = stars[i];
          if (notFaded > i) {
            stars[i].type = "solid";
          } else if (notFaded + faded > i) {
            stars[i].type = "faded";
          }
        }
      }
      return stars;
    },
    getWeatherIconCss: function(code) {
      return "msw-sw-" + code;
    },
    getReportIconCss: function(code) {
      switch (code) {
        case "no":
          return "ion-beer";
        case "dunno":
          return "ion-social-tux";
        case "yes":
          return "ion-happy";
      }
    },
    getStarIconCss: function(code) {
      switch (code) {
        case "empty":
          return "ion-ios7-star-outline faded";
        case "solid":
          return "ion-ios7-star";
        case "faded":
          return "ion-ios7-star-outline";
      }
    }
  };
});

app.factory("report", function($q, $http, webApiConfig, user, mapper, cache, authio) {
  var getAuthHeaders, latestReportId;
  getAuthHeaders = function() {
    return {
      authorization: "Bearer " + authio.getJWT()
    };
  };
  latestReportId = null;
  return {
    getCache: function(spot) {
      return cache.get("report." + spot);
    },
    get: function(spot) {
      console.log("report::get", spot);
      return $http.get(webApiConfig.url + ("report/" + spot)).then(function(res) {
        cache.put("report." + spot, res.data, "eod");
        return res.data;
      });
    },
    send: function(spot, code) {
      console.log("report::send", spot, code);
      return user.login(true).then(function() {
        return $http.post(webApiConfig.url + ("report/" + spot + "/" + code), null, {
          headers: getAuthHeaders()
        }).then(function(res) {
          latestReportId = res.data.id;
          return mapper.mapReports(res.data.report);
        });
      });
    },
    addMessage: function(msg) {
      console.log("report::addMessage", msg);
      if (latestReportId) {
        if (!msg || msg.length < 3) {
          return $q.reject(new Error("msg length [3, 150]"));
        } else {
          if (msg.length > 150) {
            msg = msg.substring(0, 149);
          }
          return $http.post(webApiConfig.url + ("report/" + latestReportId + "/message"), {
            text: msg
          }, {
            headers: getAuthHeaders()
          }).then(function(res) {
            latestReportId = null;
            return res.data;
          });
        }
      } else {
        return $q.reject(new Error("No report to add message found"));
      }
    }
  };
});

app.factory("spot", function($q, $resource, webApiConfig, mapper) {
  var inProgress, resource;
  resource = $resource(webApiConfig.url + "spots");
  inProgress = false;
  return {
    get: function(term, geo) {
      var defer;
      if (!term) {
        term = void 0;
      }
      console.log("spot::get", term, geo);
      defer = $q.defer();
      if (inProgress) {
        defer.reject({
          message: "In Progress"
        });
      } else {
        inProgress = true;
        resource.query({
          term: term,
          geo: geo
        }, (function(res) {
          inProgress = false;
          return defer.resolve(mapper.mapSpots(res));
        }), (function(response) {
          inProgress = false;
          return defer.reject(response);
        }));
      }
      return defer.promise;
    }
  };
});

app.factory("user", function($q, cache, spot, $rootScope, $ionicPopup, res, culture, geoLocator, authio, mapper) {
  var defaultUser, getHome, initialize, reset, saveChanges, setUser, showConfirmAuth, user;
  user = {};
  initialize = function() {
    var _user;
    $rootScope.res = res;
    geoLocator.getPosition();
    _user = cache.get("user");
    if (_user == null) {
      _user = defaultUser();
    }
    setUser(_user);
    return $rootScope.homeLabel = getHome().label;
  };
  setUser = function(u, save) {
    user.profile = u.profile;
    if (u.settings) {
      user.settings = u.settings;
      res.setLang(user.settings.lang);
      culture.setCulture(user.settings.culture);
    }
    $rootScope.homeLabel = getHome().label;
    if (save) {
      return saveChanges();
    }
  };
  saveChanges = function() {
    cache.put("user", user);
    authio.setData("surf_better", user.settings);
    return $rootScope.homeLabel = getHome().label;
  };
  defaultUser = function() {
    return {
      profile: null,
      settings: {
        lang: "en",
        culture: "eu",
        favs: [
          {
            code: "BR_RJ_RDJ_AR",
            name: "Arpoador",
            label: "Arpoador, Rio de Janeiro",
            isHome: true
          }
        ]
      }
    };
  };
  getHome = function() {
    return user.settings.favs.filter(function(f) {
      return f.isHome;
    })[0];
  };
  reset = function() {
    cache.clean();
    angular.copy(defaultUser(), user);
    $rootScope.homeLabel = getHome().label;
    res.setLang(user.settings.lang);
    culture.setCulture(user.settings.culture);
    saveChanges();
    return $rootScope.$broadcast("user.reset");
  };
  showConfirmAuth = function() {
    console.log(">>>user.coffee:49");
    console.log(res.str.authreqcaption);
    console.log(res.str.authreqtext);
    return $ionicPopup.confirm({
      title: res.str.authreqcaption,
      template: res.str.authreqtext
    }).then(function(res) {
      if (res) {
        return res;
      } else {
        return $q.reject();
      }
    });
  };
  return {
    initialize: initialize,
    getHome: getHome,
    setHome: function(spot) {
      var fav, _i, _len, _ref;
      _ref = user.settings.favs;
      for (_i = 0, _len = _ref.length; _i < _len; _i++) {
        fav = _ref[_i];
        fav.isHome = false;
      }
      spot.isHome = true;
      return saveChanges();
    },
    addSpot: function(spot) {
      var fav, favs;
      favs = user.settings.favs;
      fav = favs.filter(function(f) {
        return f.code === spot.code;
      })[0];
      if (!fav) {
        favs.push(spot);
        return saveChanges();
      }
    },
    removeSpot: function(spot) {
      var fav, favs;
      favs = user.settings.favs;
      fav = favs.filter(function(f) {
        return f.code === spot.code;
      })[0];
      if (fav) {
        favs.splice(favs.indexOf(fav), 1);
        if (fav.isHome) {
          favs[0].isHome = true;
        }
        return saveChanges();
      }
    },
    setLang: function(lang) {
      res.setLang(lang.code);
      user.settings.lang = lang.code;
      return saveChanges();
    },
    getLang: function() {
      return user.settings.lang;
    },
    setCulture: function(c) {
      culture.setCulture(c.code);
      user.settings.culture = c.code;
      return saveChanges();
    },
    getCulture: function() {
      return user.settings.culture;
    },
    login: function(confirm) {
      var opts;
      console.log(">>>user.coffee:97");
      if (!this.isLogin()) {
        console.log(">>>user.coffee:99");
        opts = {
          force: true
        };
        if (confirm) {
          opts.confirm = showConfirmAuth;
        }
        return authio.login("facebook", opts).then(function(res) {
          return setUser(mapper.mapUser(res));
        });
      } else {
        console.log(">>>user.coffee:104");
        return $q.when(this.user);
      }
    },
    logout: function() {
      authio.logout();
      user.profile = null;
      return saveChanges();
    },
    isLogin: function() {
      return user.profile;
    },
    reset: reset,
    user: user,
    setUser: setUser
  };
});

app.factory("res", function($rootScope, res_en, res_pt, res_fr, res_es) {
  var res_current, setLang;
  res_current = {};
  setLang = function(langName) {
    switch (langName) {
      case "pt":
        return angular.copy(res_pt, res_current);
      case "es":
        return angular.copy(res_es, res_current);
      case "fr":
        return angular.copy(res_fr, res_current);
      default:
        return angular.copy(res_en, res_current);
    }
  };
  setLang();
  return {
    str: res_current,
    setLang: setLang
  };
});

app.constant("res_en", {
  home: "Home",
  favorites: "Favorites",
  me: "Me",
  surf: "Surf !",
  dunno: "I dunno",
  nosurf: "No surf",
  swell: "Swell",
  period: "Period",
  wind: "Wind",
  addnew: "Add New",
  search: "Search",
  cancel: "Cancel",
  myinfo: "My Info",
  homebeach: "Home Beach",
  units: "Units",
  eu: "Europe",
  uk: "United Kingdom",
  us: "United States",
  reset: "Reset",
  login: "Login",
  logout: "Logout",
  authreqcaption: "Authentication needed",
  authreqtext: "To do this action you need connect your facebook account. Connect?",
  ok: "OK",
  msgsent: "You report sent !",
  addmssg: "add message here",
  send: "Send",
  select: "Select",
  coldwater: "cold water",
  crowdalert: "crowd alert",
  eventalert: "event alert",
  strongwaves: "strong waves",
  weakwaves: "weak waves",
  reportfirst: "Report First",
  name: "Name",
  langen: "English",
  langpt: "Portuguese",
  langfr: "Frances",
  langes: "Spanish",
  lang: "Language"
});

app.constant("res_es", {
  home: "Casa",
  favorites: "Favoritos",
  me: "Yo",
  surf: "Surf !",
  dunno: "No te saber",
  nosurf: "Ninguna de surf",
  swell: "Hinchar",
  period: "Período",
  wind: "Viento",
  addnew: "Añadir",
  search: "Buscar",
  cancel: "Cancelar",
  myinfo: "Mi Info",
  homebeach: "Playa de Casa",
  units: "Unidades",
  eu: "Europa",
  uk: "Reino Unido",
  us: "Estados Unidos",
  reset: "Reset",
  login: "Entrar",
  logout: "Salir",
  authreqcaption: "Autenticación necesaria",
  authreqtext: "Para terminar esta acción necesitas conectar tu cuenta de Facebook. Conecte ?",
  ok: "OK",
  msgsent: "Usted informe enviado !",
  addmssg: "añada el mensaje aquí",
  send: "Enviar",
  select: "Seleccione",
  coldwater: "agua fría",
  crowdalert: "alerta multitud",
  eventalert: "alerta de evento",
  strongwaves: "fuerte oleaje",
  weakwaves: "olas débiles",
  reportfirst: "Informe Primeiro",
  name: "Nombre",
  langen: "Inglés",
  langpt: "Portugués",
  langes: "Español",
  langfr: "Frances",
  lang: "Idioma"
});

app.constant("res_fr", {
  home: "Maison",
  favorites: "Favoris",
  me: "Moi",
  surf: "Surf !",
  dunno: "Ne sais pas",
  nosurf: "Pas de surf",
  swell: "Houle",
  period: "Période",
  wind: "Vent",
  addnew: "Ajouter",
  search: "Recherche",
  cancel: "Annuler",
  myinfo: "Mes Infos",
  homebeach: "Plage de Maison",
  units: "Unidades",
  eu: "Europe",
  uk: "Royaume-Uni",
  us: "États-Unis",
  reset: "Reset",
  login: "Entrer",
  logout: "Sortie",
  authreqcaption: "Authentification nécessaire",
  authreqtext: "Pour accomplir cette action, vous devez vous connecter à votre compte facebook . Connectez?",
  ok: "OK",
  msgsent: "Vous rapport envoyé !",
  addmssg: "ajouter un message ici",
  send: "Envoyer",
  select: "Sélectionner",
  coldwater: "eau froide",
  crowdalert: "alerte de la foule",
  eventalert: "alerte d'événement",
  strongwaves: "de fortes vagues",
  weakwaves: "vagues faibles",
  reportfirst: "Premier Rapport",
  name: "Nom",
  langen: "Anglais",
  langpt: "Portugais",
  langes: "Espagnol",
  langfr: "Frances",
  lang: "Langue"
});

app.constant("res_pt", {
  home: "Casa",
  favorites: "Preferidos",
  me: "Eu",
  surf: "Surf !",
  dunno: "Nem sei",
  nosurf: "Não há surf",
  swell: "Inchamento",
  period: "Periodo",
  wind: "Ventro",
  addnew: "Adicionar",
  search: "Buscar",
  cancel: "Cancelar",
  myinfo: "Meu Info",
  homebeach: "Praia da Casa",
  units: "Unidades",
  eu: "Europa",
  uk: "Reino Unido",
  us: "Estados Unidos",
  reset: "Reset",
  login: "Entrar",
  logout: "Sair",
  authreqcaption: "Autenticação necessária",
  authreqtext: "Para fazer esta ação voce precisa conectar sua conta do facebook. Conectar ?",
  ok: "OK",
  msgsent: "Seu relatório enviado !",
  addmssg: "adicionar mensagem aqui",
  send: "Enviar",
  select: "Selecione",
  coldwater: "agua fria",
  crowdalert: "alerta multidão",
  eventalert: "alerta de evento",
  strongwaves: "ondas fortes",
  weakwaves: "ondas fracas",
  reportfirst: "Ser o Primeiro",
  name: "Nome",
  langen: "Inglês",
  langpt: "Português",
  langfr: "Frances",
  langes: "Espanhol",
  lang: "Idioma"
});
